/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/


#include <SDL\SDL.h>


#include "muGUI_widget.h"
#include "BFont.h"
#include "SDL_prim.h"
//#include "SDL_gfx/SDL_gfxPrimitives.h"
#include "SDL_gfx/SDL_rotozoom.h"
/*
Widget ID Define for direct Acces
Not very clean but working
WARNING : 
If a widget is added to the GUI take care of the ID order
*/

#define		nSX2_WID_VIDEO_OUTPUT			0
#define		nSX2_WID_EMU_OUTPUT				1
#define		nSX2_WID_OPCODE_OUTPUT			2
#define		nSX2_WID_REGISTER_OUTPUT		3
#define		nSX2_WID_COP1REGISTER_OUTPUT	4


/* Max GUI Widget : Not very Used for now */
#define		muGUI_MAX_WIDGET		256


/* muGUI Status */
#define		muGUI_STATUS_RUNNING	1
#define		muGUI_STATUS_STOP		2	



/*muGUI Style */
#define		muGUI_STYLE_NUMBER		3	
#define		muGUI_STYLE_DEFAULT		0
#define		muGUI_STYLE_DEBUG		1
#define		muGUI_STYLE_FULLSCREEN	2



/* some defines */
#define		TRUE 	1
#define		FALSE 	0


/* Main muGUI Structure */

typedef struct _muGUI {
	
	SDL_Surface * MainScreen;			// the Surface where the GUI draw
	SDL_Surface * MainScreen_FullScreen;
    BFont_Info *Font1;					// the GUI Fonts
	BFont_Info *Font2;					//
	
	unsigned int	nbWidget;			//current number of GUI Widget
	unsigned char	status;				//current GUI status
	
	unsigned char	guiStyle;			//
		
	muGUIwidget myWid[muGUI_MAX_WIDGET];	//Static Memory for Widget Definitions
											//NOTE : I know not very clean ( prefer malloc but not enough time )
	
	/* Functions Pointer */
	void (*addWidget)( void * , muGUIwidget *);		//Add a Widget to the GUI
	void (*clearScreen) (void * );					//Clear the GUI screen
	
	void (*run)(void * );							//Main loop
	void (*destroy)(void * );						//Destroy the GUI
	void (*updateStyle)(void * );						//Destroy the GUI
	
	void (*IdleProc)(void);							//Function to execute when the GUI has done all internal things

	
} muGUI;


/* External Declaration */

extern muGUI nSX2GUI;
extern SDL_Surface * video_screen;

/* Functions Declarations */

int 	muGUI_Init 				( muGUI * fgui );
void 	muGUI_Destroy 			( void * this );
void 	muGUI_MainLoop 			( void * this );
void 	muGUI_AddWidget 		( void * this , muGUIwidget * fWid );
void 	muGUI_ClearScreen 		( void * this );
void 	muGUI_defaultIdleProc 	( void );
void 	muGUI_UpdateStyle 		(  void * this );

/* Easy functions to print Text to the Output Widget */

void PrintToEmuOutput 			(  char * ftext );
void PrintToOpcodeOutput 		(  char * ftext );
void PrintToRegistersOutput 	(  char * ftext );
void PrintToCOP1RegistersOutput (  char * ftext );