/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <SDL/SDL.h>


#include "nSX2.h"
#include "plugin_gs_04/PS2Edefs.h"
#include "muGUI/muGUI.h"


Mips_CPU 		MipsCpu;
Bios_Hw  		Ps2Bios;

SDL_Surface		* MainScreen;
SDL_Event		* MainSDLEvent;

muGUI 			nSX2GUI;
char 			ElfToExecute[256];

/* This function may run in a separate event thread */
int FilterEvents(const SDL_Event *event) {
    static int boycott = 1;
    static int DragAndDrop = 0;
	static int WidgetID_Click;
	int boucle;

	int result;

    /* This quit event signals the closing of the window */
    if ( (event->type == SDL_QUIT) && boycott ) {
        printf("Quit event filtered out -- try again.\n");
        boycott = 0;
        return(0);
    }
    
    if ( (event->type == SDL_QUIT) && !boycott ) {
        printf("Quit event filtered out -- try again.\n");
        boycott = 0;
        nSX2GUI.IdleProc=muGUI_nSX2EndingProc;
        return(0);
    }
    
    
    
    if ( event->type == SDL_MOUSEMOTION ) {
        	//printf("Mouse moved to (%d,%d)\n",event->motion.x, event->motion.y);
        
        if ( DragAndDrop == 1 ) {
        		nSX2GUI.myWid[ WidgetID_Click ].x = nSX2GUI.myWid[ WidgetID_Click ].x + event->motion.xrel ;
        		nSX2GUI.myWid[ WidgetID_Click ].y = nSX2GUI.myWid[ WidgetID_Click ].y + event->motion.yrel ;
        		
        		if ( nSX2GUI.myWid[ WidgetID_Click ].x  <= 0 ) nSX2GUI.myWid[ WidgetID_Click ].x = 0 ;
        		if ( nSX2GUI.myWid[ WidgetID_Click ].y  <= 0 ) nSX2GUI.myWid[ WidgetID_Click ].y = 0 ;
        		
        		//nSX2GUI.myWid[ WidgetID_Click ].NeedRefresh = TRUE;
        		nSX2GUI.myWid[ WidgetID_Click ].moved = TRUE;
        	}
        	
        	
        return(0);    /* Drop it, we've handled it */
    }
    
       if ( event->type == SDL_MOUSEBUTTONDOWN ) {
        	
        	
        	//Check TitleBarClick
        	WidgetID_Click = -1;
        	result = -1;
        	for ( boucle = 0 ; boucle < nSX2GUI.nbWidget ; boucle++) {
			
				result = nSX2GUI.myWid[ boucle ].isClick( &(nSX2GUI.myWid[ boucle ]) , &nSX2GUI ,event->button.x , event->button.y);
				
				switch ( result ) {
					
					case MUGUI_WID_TITLEBAR_OTHER: {
						DragAndDrop = 1 ;
						WidgetID_Click = boucle ;
						break;
					}
				
					case MUGUI_WID_TITLEBAR_BUTTON_1: {
						if ( nSX2GUI.myWid[ boucle ].Status == MUGUI_WID_STATUS_SHOW ) {
							 	nSX2GUI.myWid[ boucle ].previous_h = nSX2GUI.myWid[ boucle ].h ;
								nSX2GUI.myWid[ boucle ].h = 22;
								nSX2GUI.myWid[ boucle ].Status = MUGUI_WID_STATUS_HIDE;
							}
						else
							{
								nSX2GUI.myWid[ boucle ].h = nSX2GUI.myWid[ boucle ].previous_h;
								nSX2GUI.myWid[ boucle ].Status = MUGUI_WID_STATUS_SHOW;
							}
							
						
						nSX2GUI.myWid[ boucle ].moved = TRUE;
						break;
						
						
					}
				
				
				}
			
			}
        	
        	
        	
        return(0);    /* Drop it, we've handled it */
    }
    
    if ( event->type == SDL_MOUSEBUTTONUP ) {
        	
            if ( DragAndDrop == 1 ) {
            	DragAndDrop = 0 ;
            	WidgetID_Click = - 1;
        	
        	}

        	
        	
        	
        return(0);    /* Drop it, we've handled it */
    }
    
    
    
	if ( event->type ==  SDL_KEYDOWN ) {
		switch (event->key.keysym.sym)	{
	   		case SDLK_ESCAPE: 
	   			MipsCpu.halt = 1 ;
	   			nSX2GUI.IdleProc=muGUI_nSX2EndingProc;	
	   			break;
	   		case SDLK_F1:
	   		
	   			MipsCpu.halt = 1 ; 
	   			break;
	   		   		
	   	
	   		case SDLK_F2:    
	   			MipsCpu.halt = 0; 
	   			break;
	   	
   			case SDLK_F3: 
   				if ( debug_op == 0 ) debug_op = 1 ;
   				else debug_op = 0;
				break;
			
			case SDLK_F4:
					nSX2GUI.guiStyle = nSX2GUI.guiStyle + 1;
					if ( nSX2GUI.guiStyle >= muGUI_STYLE_NUMBER )  nSX2GUI.guiStyle = 0;
			
					nSX2GUI.updateStyle(&nSX2GUI);	
				break;

			case SDLK_F5:
					
				break;


			

	   		default:
	    
	  	}
		return 0;
	}

    if ( event->type ==  SDL_KEYUP ) {
		switch (event->key.keysym.sym)
	  	{
	   		case SDLK_ESCAPE:     	break;
	   		case SDLK_F1:     		break;
   			case SDLK_F2:     		break;
	   		case SDLK_F3:    		break;
	   		case SDLK_F4:    		break;
	   		case SDLK_F5:  MipsCpu.halt = 2 ; 	  break;
	   		default:
	    
	  	}
		return 0;
    }
    
    
    
    
    
    return(1);
}







/*
Initialisation of the EMU
*/
void muGUI_nSX2InitProc ( void ) {
	char 		tempText[100];		//for displaying text to the widget
	static int 	nsx2InitState = 0;	//Function State
	static int	IsInitOK = 0;		//
	int 		result;				//fonction return 
	char 		GSMainTitle[256];	//main windows title	
	
	
	switch ( nsx2InitState ) {
		/* Print some infos */
		case 0:	{
				
			sprintf(tempText,"nSX2 %d.%d by Muad - 2002 ( build date : %s )",  nSX2_VERSION, nSX2_BUILD,sSX2_BUILD_DATE);
			PrintToEmuOutput(tempText);	
			
			sprintf(tempText,"|  web  : http://nsx2.emulation64.com");
			PrintToEmuOutput(tempText);	
			
			sprintf(tempText,"|_ mail : atreides.muaddib@caramail.com");
			PrintToEmuOutput(tempText);		
		
			IsInitOK = 0;

			break;
		}
		
		/*Open the elf File */
		case 1: {
			result = ElfOpenFile(ElfToExecute);					if ( result == FALSE )  IsInitOK++;
			break;			
		}
		
		/*Open the BIOS File */
		case 2: {
			//result = BiosOpenFile( "bios/scph10000.bin" ) ;		if ( result == FALSE )  IsInitOK++;
			break;		
		}
		
		/*Various Memory Allocation */
		case 3: {
			result = MipsMemoryAlloc();							if ( result == FALSE )  IsInitOK++;
			result = MipsSpecialAreaMemoryAlloc( );				if ( result == FALSE )  IsInitOK++;
			result = MipsGSAreaMemoryAlloc();					if ( result == FALSE )  IsInitOK++;
			result = MipsBiosMemoryAlloc( );					if ( result == FALSE )  IsInitOK++;
			break;
		}
	
		
		/*If something wrong*/
		case 4: {
			if ( IsInitOK != 0 ) {
				sprintf(tempText,"FATAL ERROR while emulator initialisation....Sorry Exiting");	
				PrintToEmuOutput(tempText);
				nSX2GUI.status = muGUI_STATUS_STOP;
			}
			break;
		}
	
		/*Read the header of the Elf File*/
		case 5: {
			
			ElfLoadHeader();
		
			/* */
			//ElfPrintInfo();
			break;
		}
	
		/*Copy the program to memory according the elf header*/
		case 6: {	
			CopyProgramToMemory(  ) ;
			break;
		}
		
		/*Copy data to memory according the elf header*/
		case 7: {	
			CopySectionToMemory( );
			break;
		}
		
		/*Copy Bios to Memory */
		case 8: {
			//CopyBiosToMemory ( );	
			break;	
		}
	
		/* Initialisation of GS plugin */
		case 9: {	
			
			GSinit();
			result = GSopen(MainScreen ,GSMainTitle );
		
			if ( result != 0 ) {
				sprintf(tempText,"FATAL ERROR while graphics initialisation...Sorry Exiting");
				PrintToEmuOutput(tempText);
				nSX2GUI.status = muGUI_STATUS_STOP;
				
			} else {
				sprintf(tempText,"GS:OK");
				PrintToEmuOutput(tempText);			
			}
			break;	
		}

		/*Various PS2 Initialisation */
		case 10: {	
			
			Ps2Bios.NeedUpdateScreen 			= 0;
			MipsCpu.PC 							= MipsCpu.EntryPointAdd ;	//Start Program At Addr
			MipsCpu.GPR[CPU_REG_GP].lo			= 0x81F80000;				//GP
			MipsCpu.GPR[CPU_REG_SP].lo			= 0x81F00000;				//SP
			MipsCpu.CPR0[12][0]					= 0x10900001;				//Reg Status of COP0
			MipsCpu.CPR0[15][0]					= 0x2E20	;				//Reg PrID of COP0
			MipsCpu.Nb_instructions 			= 0;
			Ps2Bios.NbSema 						= 0;
			
			
			/*
			Create some pointeurs to val for performing the conversion by value of :
			int to float 
			and 
			float to int
			without change the way of store
			for exemple :
				0x4863D000 = 233280.0000
				and not
				0x4863D000 = 1214500864.0000
			*/
			for ( result = 0 ; result < 32 ; result++ ) {
			
			     MipsCpu.FPR1_p_float[result]=(float *)&(MipsCpu.FPR1[result].lo);
   
                }
			
			/*Temp Debug print*/
			printf("Nb Of Prog Section : %ld \n",MipsCpu.NbOfExecutableSection);
			printf("Prog Start Add %lx - End : %lx\n",MipsCpu.OpcodeStartAdd[0],MipsCpu.OpcodeEndAdd[0]); 
			
			MipsCpuPrefetchOpcode();
			
			break;
			
		}	

		/* Emulation Start Here...*/
		case 11: {
			/*Change the Idle proc of the Gui*/

			nSX2GUI.IdleProc=muGUI_nSX2Proc;
			MipsCpu.halt = 0;
				
			sprintf(tempText,"Start Interpreter....");
			PrintToEmuOutput(tempText);	
			break;
		}
		
		/* MUST NEVER DO THIS */
		default: {
			sprintf(tempText,"Too Bad Muad...");
			PrintToEmuOutput(tempText);	
			break;
		}
		
	}
	
	/* next State when calling again this fucntion */
	nsx2InitState ++;
	
}


/*
Main Function of the EMU
*/
void muGUI_nSX2Proc ( void ) {
		
		_u16	boucle;
		// For debugging... 
		//if ( MipsCpu.PC == 0x00404158) debug_op = 1;				//...after acessing a opcode
		//if ( MipsCpu.Nb_instructions > 557000 ) debug_op = 1;		//...after a number of opcode
		
		//if ( MipsCpu.PC == 0x00202930 ) result++;	
		//if ( result == 1 ) debug_op = 1;	
				
	/*
		If the debug mode is running, I can't exec a block of opcode
	
	*/
	switch( MipsCpu.halt ) {

		case 0: 
			if ( debug_op == 0 ) {
				for ( boucle = 0 ; boucle < 1000 ; boucle ++ ) MipsUpdateCpu(); //Execute a Block of opcodes
			} else MipsUpdateCpu();												//Execute the current opcode
			
		break;
		
		case 2:
			MipsUpdateCpu();	//Execute the current opcode
			MipsCpu.halt = 1;	//And Stop
		break;
		
		
	}
	
	/*Execute DMA stuff*/
	DmaUpdate();
	
	/*Execute GS stuff*/
	GSUpdate();
	
	
	/* In future add other stuff like PadUpdate , SoundUpdate , etc.... */
	

	

	if ( Ps2Bios.MustExecHandler == DMA_CH5 ) {
	   //printf(".");
	   if ( ( MipsCpu.PC < Ps2Bios.DmaH[ DMA_CH5 ].Add ) || ( MipsCpu.PC >= Ps2Bios.DmaH[ DMA_CH5 ].EndAdd ) ) {
	   
	       //memcpy( MipsCpu.GPR , Ps2Bios.SaveReg , (sizeof(_u128)) * 34 );
	     
	   
	       MipsCpu.PC = Ps2Bios.DmaH[ DMA_CH5 ].ReturnAdd;
	       Ps2Bios.MustExecHandler =   0xFFFF;
           printf("\nEnd Handler\n");
	       
        }
	  
	
	}
	   
	
	
/*	
	if ( MipsCpu.PC == 0x040EB40) {
            debug_op = 1;
            MipsCpu.halt = 1;
            }
*/           	
}





/*
Stop the Emu
*/
void muGUI_nSX2EndingProc ( void ) {

	static int 	nsx2EndingState = 0;
	char tempText[100];
	
		
	switch ( nsx2EndingState ) {
		
		/*Print some info*/
		case 0:	{
			PrintToEmuOutput("...Stop Interpreter");	
			break;
		}
		
		/*Print some info about the CPU Status*/	
		case 1:	{		
			sprintf(tempText,"Stop at PC = 0x%8.8llx after %lld instructions",MipsCpu.PC, MipsCpu.Nb_instructions);
			PrintToEmuOutput(tempText);	
			
	
			/*
			PrintDebugOpcode	();
			MipsCpuPrintReg		();
			MipsCpuFPR1PrintReg	();
			*/
			break;
		}
		
		/*Close the File Handle of the Elf File*/
		case 2:	{
			ElfCloseFile();
			break;
		}
		
		/*Close the File Handle of the Bios File*/		
		case 3:	{
			//BiosCloseFile( ) ;
			break;
		}
		
		/*Free All Emu Memory*/
		case 4:	{	
			FreeAllMemory();
			break;
		}
		
		/*Free GS plugin Memory*/
		case 5:	{	
			
		
			
			GSclose();
			break;
		}
	
		/*Add a delay for showing last message... not very clean*/	
		case 6:	{
			SDL_Delay(2000);
			break;
		}
		
		/*Stop the GUI Main loop*/
		case 7:	{	
			nSX2GUI.status = muGUI_STATUS_STOP;
			break;	
		}
		
		
		
	}
		
	/* next State when calling again this fucntion */
	nsx2EndingState++;
}
 




int main( void ) {
	
	int 	result;				//fonction return 
	char 	GSMainTitle[256];	//main windows title
	
	SDL_Surface *screen;				//The Video Screen
	
    Uint32 rmask, gmask, bmask, amask;	//Mask for the SDL Surface
	muGUIwidget tempWidget;				//Temporary Widget

	/* Initialize SDL */
	if ( SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER ) < 0 ) {
		printf("Couldn't initialize SDL: %s\n",SDL_GetError());
		exit(1);
	}
	atexit(SDL_Quit);


	/* Read config File
		If errors happend, no problem this functions load default config
	*/
	result = nSX2LoadConfig();							


	/* Set the main GUI video Mode */
	screen = SDL_SetVideoMode(800, 600, muGUI_MainScreenBPP, SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_HWPALETTE );
	if ( screen == NULL ) {
		printf("Couldn't set video mode: %s\n",SDL_GetError());
		fflush(stdout);
		exit(1);
	}
	
	/* SDL Filter Event for the GUI*/
   	SDL_SetEventFilter(FilterEvents);


	/*
	WARNING: MASK NOT USABLE FOR AN ANOTHER APP
	*/

	#if SDL_BYTEORDER == SDL_BIG_ENDIAN
	    rmask = 0x0000ff00;
	    gmask = 0x00ff0000;
	    bmask = 0xff000000;
	    amask = 0x000000ff;
	#else
	    rmask = 0x00ff0000;
	    gmask = 0x0000ff00;
	    bmask = 0x000000ff;
	    amask = 0xff000000;
	#endif

	/* Creation of the MainPS2Output Video*/
	MainScreen = SDL_CreateRGBSurface( SDL_HWSURFACE  , muGUI_MainScreenW,muGUI_MainScreenH, muGUI_MainScreenBPP,rmask, gmask, bmask, amask);
    if(MainScreen == NULL) printf("CreateRGBSurface failed: %s\n", SDL_GetError());

 
	/**************************************************************************************************/


	/* GUI Initialisation */
	muGUI_Init ( &nSX2GUI );
	
	/* Add the main PS2 screen to the GUI*/
	muGUIwidget_init ( &tempWidget , MUGUI_WID_IMAGE , 10 ,10 , muGUI_MainScreenW+2 , muGUI_MainScreenH+22 , "VideoOutput" );
	tempWidget.addImage(&tempWidget,MainScreen);
	nSX2GUI.addWidget(&nSX2GUI,&tempWidget);
	
	
	/* Add the EmuOutput widget*/
	muGUIwidget_init ( &tempWidget , MUGUI_WID_TEXT , 10 , muGUI_MainScreenH+42 , 450 , 170 , "EmuOutput" );
	nSX2GUI.addWidget(&nSX2GUI,&tempWidget);

	/* Add the OpcodeOutput widget */
	muGUIwidget_init ( &tempWidget , MUGUI_WID_TEXT , 500 + 20 , muGUI_MainScreenH+42 , 250 , 170 , "Opcodes" );
	nSX2GUI.addWidget(&nSX2GUI,&tempWidget);

	/* Add the RegisterOutput widget */
	muGUIwidget_init ( &tempWidget , MUGUI_WID_TEXT , 20 + 500 , 10 , 180 , 378 + 22 , "CpuRegs" );
	nSX2GUI.addWidget(&nSX2GUI,&tempWidget);
		
	/* Add the RegisterCOP1Output widget */
	muGUIwidget_init ( &tempWidget , MUGUI_WID_TEXT , 150 + 500 , 32 , 180 , 358 + 22 , "FPR1Regs" );
	nSX2GUI.addWidget(&nSX2GUI,&tempWidget);


	nSX2GUI.updateStyle(&nSX2GUI);	

	/* Change the Windows title */
	sprintf(GSMainTitle, " %s %d.%2.2d - %s", "nSX2", nSX2_VERSION, nSX2_BUILD,ElfToExecute);
	SDL_WM_SetCaption ( GSMainTitle , NULL );
	

	/* Init */		
	nSX2GUI.IdleProc=muGUI_nSX2InitProc;
	
	/* and run*/
	nSX2GUI.run(&nSX2GUI);	
	
	/* Destroy all Gui elements*/
	nSX2GUI.destroy(&nSX2GUI);
	
	/* clean Quit SDL */
	SDL_Quit();

	/*All done...*/	
	return TRUE;
	
}
